Index: kernel/arch/sparc64/src/mm/sun4u/tsb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/tsb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/mm/sun4u/tsb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup sparc64mm	
+/** @addtogroup sparc64mm
  * @{
  */
@@ -37,8 +37,8 @@
 #include <arch/mm/page.h>
 #include <arch/barrier.h>
+#include <assert.h>
 #include <mm/as.h>
 #include <typedefs.h>
 #include <macros.h>
-#include <debug.h>
 
 /** Invalidate portion of TSB.
@@ -58,6 +58,6 @@
 	size_t cnt;
 	
-	ASSERT(as->arch.itsb);
-	ASSERT(as->arch.dtsb);
+	assert(as->arch.itsb);
+	assert(as->arch.dtsb);
 	
 	i0 = (page >> MMU_PAGE_WIDTH) & ITSB_ENTRY_MASK;
@@ -85,5 +85,5 @@
 	size_t entry;
 
-	ASSERT(index <= 1);
+	assert(index <= 1);
 	
 	as = t->as;
@@ -130,5 +130,5 @@
 	size_t entry;
 	
-	ASSERT(index <= 1);
+	assert(index <= 1);
 
 	as = t->as;
Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,7 +37,7 @@
 #include <arch/mm/pagesize.h>
 #include <arch/mm/tlb.h>
+#include <assert.h>
 #include <genarch/mm/page_ht.h>
 #include <genarch/mm/asid_fifo.h>
-#include <debug.h>
 #include <config.h>
 #include <arch/sun4v/hypercall.h>
@@ -50,5 +50,5 @@
 #include <bitops.h>
 #include <macros.h>
-#include <memstr.h>
+#include <mem.h>
 
 #endif /* CONFIG_TSB */
@@ -121,5 +121,5 @@
 	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
 	
-	ASSERT(as->arch.tsb_description.tsb_base);
+	assert(as->arch.tsb_description.tsb_base);
 	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
 	
@@ -160,5 +160,5 @@
 	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
 	
-	ASSERT(as->arch.tsb_description.tsb_base);
+	assert(as->arch.tsb_description.tsb_base);
 	
 	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
Index: kernel/arch/sparc64/src/mm/sun4v/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,4 +43,5 @@
 #include <arch/mm/tlb.h>
 #include <arch/interrupt.h>
+#include <assert.h>
 #include <interrupt.h>
 #include <arch.h>
@@ -215,5 +216,5 @@
 	bool found = page_mapping_find(AS, va, true, &t);
 	if (found && PTE_EXECUTABLE(&t)) {
-		ASSERT(t.p);
+		assert(t.p);
 
 		/*
@@ -265,5 +266,5 @@
 	bool found = page_mapping_find(as, va, true, &t);
 	if (found) {
-		ASSERT(t.p);
+		assert(t.p);
 
 		/*
@@ -303,5 +304,5 @@
 	bool found = page_mapping_find(as, va, true, &t);
 	if (found && PTE_WRITABLE(&t)) {
-		ASSERT(t.p);
+		assert(t.p);
 
 		/*
@@ -345,5 +346,5 @@
 	__hypercall_fast_ret1(0, 0, 0, 0, 0, CPU_MYID, &myid);
 
-	ASSERT(mmu_fsas[myid].dft < 16);
+	assert(mmu_fsas[myid].dft < 16);
 
 	printf("condition which caused the fault: %s\n",
Index: kernel/arch/sparc64/src/mm/sun4v/tsb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tsb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/mm/sun4v/tsb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,8 +39,8 @@
 #include <arch/mm/page.h>
 #include <arch/barrier.h>
+#include <assert.h>
 #include <mm/as.h>
 #include <typedefs.h>
 #include <macros.h>
-#include <debug.h>
 
 /** Invalidate portion of TSB.
@@ -60,5 +60,5 @@
 	size_t cnt;
 	
-	ASSERT(as->arch.tsb_description.tsb_base);
+	assert(as->arch.tsb_description.tsb_base);
 	
 	i0 = (page >> MMU_PAGE_WIDTH) & TSB_ENTRY_MASK;
Index: kernel/arch/sparc64/src/smp/sun4u/ipi.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4u/ipi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/smp/sun4u/ipi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
 #include <smp/ipi.h>
 #include <arch/smp/sun4u/ipi.h>
+#include <assert.h>
 #include <cpu.h>
 #include <arch.h>
@@ -103,5 +104,5 @@
 		panic("Interrupt Dispatch Status busy bit set\n");
 	
-	ASSERT(!(pstate_read() & PSTATE_IE_BIT));
+	assert(!(pstate_read() & PSTATE_IE_BIT));
 	
 	do {
@@ -185,5 +186,5 @@
 void ipi_unicast_arch(unsigned int cpu_id, int ipi)
 {
-	ASSERT(&cpus[cpu_id] != CPU);
+	assert(&cpus[cpu_id] != CPU);
 	
 	if (ipi == IPI_SMP_CALL) {
Index: kernel/arch/sparc64/src/smp/sun4u/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,5 @@
 #include <config.h>
 #include <macros.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <log.h>
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,7 @@
 #include <macros.h>
 #include <func.h>
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <print.h>
Index: kernel/arch/sparc64/src/sparc64.c
===================================================================
--- kernel/arch/sparc64/src/sparc64.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/sparc64.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -70,5 +70,5 @@
 
 	if (config.cpu_active == 1) {
-		STATIC_ASSERT(UWB_SIZE <= UWB_ALIGNMENT);
+		static_assert(UWB_SIZE <= UWB_ALIGNMENT, "");
 		/* Create slab cache for the userspace window buffers */
 		uwb_cache = slab_cache_create("uwb_cache", UWB_SIZE,
Index: kernel/arch/sparc64/src/trap/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/trap/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,5 @@
 #include <interrupt.h>
 #include <ddi/irq.h>
-#include <typedefs.h>
+#include <stdbool.h>
 #include <debug.h>
 #include <arch/asm.h>
Index: kernel/arch/sparc64/src/trap/sun4u/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/sun4u/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/trap/sun4u/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #include <interrupt.h>
 #include <ddi/irq.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <debug.h>
 #include <arch/asm.h>
Index: kernel/arch/sparc64/src/trap/sun4v/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #include <interrupt.h>
 #include <ddi/irq.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <debug.h>
 #include <arch/asm.h>
Index: kernel/arch/sparc64/src/trap/trap.c
===================================================================
--- kernel/arch/sparc64/src/trap/trap.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/sparc64/src/trap/trap.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,14 +35,4 @@
 
 #include <arch/trap/trap.h>
-#include <arch/trap/trap_table.h>
-#include <arch/trap/regwin.h>
-#include <arch/trap/exception.h>
-#include <arch/trap/interrupt.h>
-#include <arch/trap/mmu.h>
-#include <arch/asm.h>
-#include <memstr.h>
-#include <debug.h>
-#include <typedefs.h>
-#include <arch/drivers/tick.h>
 
 /** Initialize trap table. */
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -169,4 +169,5 @@
 ifeq ($(CONFIG_MULTIBOOT), y)
 GENARCH_SOURCES += \
+	genarch/src/multiboot/common.c \
 	genarch/src/multiboot/multiboot.c \
 	genarch/src/multiboot/multiboot2.c
Index: kernel/genarch/include/genarch/drivers/amdm37x/gpt.h
===================================================================
--- kernel/genarch/include/genarch/drivers/amdm37x/gpt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/drivers/amdm37x/gpt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 #define KERN_AMDM37x_GPT_H_
 
+#include <assert.h>
 #include <typedefs.h>
 #include <mm/km.h>
@@ -211,5 +212,5 @@
 	km_unmap((uintptr_t)clksel, 4);
 
-	ASSERT(timer);
+	assert(timer);
 	/* Map control register */
 	timer->regs = (void*) km_map(ioregs, iosize, PAGE_NOT_CACHEABLE);
@@ -247,6 +248,6 @@
 static inline void amdm37x_gpt_timer_ticks_start(amdm37x_gpt_t* timer)
 {
-	ASSERT(timer);
-	ASSERT(timer->regs);
+	assert(timer);
+	assert(timer->regs);
 	/* Enable overflow interrupt */
 	timer->regs->tier |= AMDM37x_GPT_TIER_OVF_IRQ_FLAG;
@@ -257,6 +258,6 @@
 static inline bool amdm37x_gpt_irq_ack(amdm37x_gpt_t* timer)
 {
-	ASSERT(timer);
-	ASSERT(timer->regs);
+	assert(timer);
+	assert(timer->regs);
 	/* Clear all pending interrupts */
 	const uint32_t tisr = timer->regs->tisr;
Index: kernel/genarch/include/genarch/drivers/bcm2835/irc.h
===================================================================
--- kernel/genarch/include/genarch/drivers/bcm2835/irc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/drivers/bcm2835/irc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #define KERN_BCM2835_IRQC_H_
 
+#include <assert.h>
 #include <typedefs.h>
 
@@ -158,5 +159,5 @@
 static inline void bcm2835_irc_enable(bcm2835_irc_t *regs, unsigned inum)
 {
-	ASSERT(inum < BCM2835_IRQ_COUNT);
+	assert(inum < BCM2835_IRQ_COUNT);
 	regs->irq_enable[IRQ_TO_BANK(inum)] |= (1 << IRQ_TO_NUM(inum));
 }
@@ -164,5 +165,5 @@
 static inline void bcm2835_irc_disable(bcm2835_irc_t *regs, unsigned inum)
 {
-	ASSERT(inum < BCM2835_IRQ_COUNT);
+	assert(inum < BCM2835_IRQ_COUNT);
 	regs->irq_disable[IRQ_TO_BANK(inum)] |= (1 << IRQ_TO_NUM(inum));
 }
Index: kernel/genarch/include/genarch/drivers/bcm2835/timer.h
===================================================================
--- kernel/genarch/include/genarch/drivers/bcm2835/timer.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/drivers/bcm2835/timer.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #ifndef KERN_BCM2835_TIMER_H_
 
+#include <assert.h>
 #include <typedefs.h>
 #include <mm/km.h>
@@ -66,5 +67,5 @@
 static inline void bcm2835_timer_start(bcm2835_timer_t* timer)
 {
-	ASSERT(timer);
+	assert(timer);
 	/* Clear pending interrupt on channel 1 */
 	timer->cs |= BCM2835_TIMER_CS_M1;
@@ -75,5 +76,5 @@
 static inline void bcm2835_timer_irq_ack(bcm2835_timer_t* timer)
 {
-	ASSERT(timer);
+	assert(timer);
 	/* Clear pending interrupt on channel 1 */
 	timer->cs |= BCM2835_TIMER_CS_M1;
Index: kernel/genarch/include/genarch/drivers/omap/irc.h
===================================================================
--- kernel/genarch/include/genarch/drivers/omap/irc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/drivers/omap/irc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 #define KERN_OMAP_IRQC_H_
 
+#include <assert.h>
 #include <typedefs.h>
 
@@ -230,5 +231,5 @@
 static inline void omap_irc_enable(omap_irc_regs_t *regs, unsigned inum)
 {
-	ASSERT(inum < OMAP_IRC_IRQ_COUNT);
+	assert(inum < OMAP_IRC_IRQ_COUNT);
 	const unsigned set = inum / 32;
 	const unsigned pos = inum % 32;
@@ -243,5 +244,5 @@
 static inline void omap_irc_disable(omap_irc_regs_t *regs, unsigned inum)
 {
-	ASSERT(inum < OMAP_IRC_IRQ_COUNT);
+	assert(inum < OMAP_IRC_IRQ_COUNT);
 	const unsigned set = inum / 32;
 	const unsigned pos = inum % 32;
Index: kernel/genarch/include/genarch/fb/bfb.h
===================================================================
--- kernel/genarch/include/genarch/fb/bfb.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/fb/bfb.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_BFB_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/genarch/include/genarch/mm/as_ht.h
===================================================================
--- kernel/genarch/include/genarch/mm/as_ht.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/mm/as_ht.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 
 #include <mm/mm.h>
-#include <adt/list.h>
+#include <adt/hash_table.h>
 #include <typedefs.h>
 
@@ -46,5 +46,5 @@
 
 typedef struct pte {
-	link_t link;		/**< Page hash table link. */
+	ht_link_t link;		/**< Page hash table link. */
 	struct as *as;		/**< Address space. */
 	uintptr_t page;		/**< Virtual memory page. */
Index: kernel/genarch/include/genarch/mm/page_ht.h
===================================================================
--- kernel/genarch/include/genarch/mm/page_ht.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/mm/page_ht.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -46,10 +46,6 @@
 #include <adt/hash_table.h>
 
-#define PAGE_HT_KEYS  2
 #define KEY_AS        0
 #define KEY_PAGE      1
-
-#define PAGE_HT_ENTRIES_BITS  13
-#define PAGE_HT_ENTRIES       (1 << PAGE_HT_ENTRIES_BITS)
 
 /* Macros for querying page hash table PTEs. */
@@ -66,5 +62,5 @@
 extern slab_cache_t *pte_cache;
 extern hash_table_t page_ht;
-extern hash_table_operations_t ht_operations;
+extern hash_table_ops_t ht_ops;
 
 #endif
Index: kernel/genarch/include/genarch/multiboot/multiboot.h
===================================================================
--- kernel/genarch/include/genarch/multiboot/multiboot.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/multiboot/multiboot.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -71,4 +71,6 @@
 } __attribute__((packed)) multiboot_module_t;
 
+extern void multiboot_cmdline(const char *);
+
 extern void multiboot_extract_command(char *, size_t, const char *);
 extern void multiboot_extract_argument(char *, size_t, const char *);
Index: kernel/genarch/include/genarch/multiboot/multiboot2.h
===================================================================
--- kernel/genarch/include/genarch/multiboot/multiboot2.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/multiboot/multiboot2.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,5 @@
 #define MULTIBOOT2_TAG_MODULE_ALIGN   6
 
+#define MULTIBOOT2_TAG_CMDLINE 1
 #define MULTIBOOT2_TAG_MODULE  3
 #define MULTIBOOT2_TAG_MEMMAP  6
@@ -73,4 +74,9 @@
 	uint32_t reserved;
 } __attribute__((packed)) multiboot2_info_t;
+
+/** Multiboot2 cmdline structure */
+typedef struct {
+	char string[0];
+} __attribute__((packed)) multiboot2_cmdline_t;
 
 /** Multiboot2 modules structure */
@@ -138,4 +144,5 @@
 	uint32_t size;
 	union {
+		multiboot2_cmdline_t cmdline;
 		multiboot2_module_t module;
 		multiboot2_memmap_t memmap;
Index: kernel/genarch/include/genarch/ofw/ofw_tree.h
===================================================================
--- kernel/genarch/include/genarch/ofw/ofw_tree.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/include/genarch/ofw/ofw_tree.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,5 @@
 #define KERN_OFW_TREE_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/genarch/src/acpi/acpi.c
===================================================================
--- kernel/genarch/src/acpi/acpi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/acpi/acpi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 #include <genarch/acpi/madt.h>
 #include <arch/bios/bios.h>
+#include <debug.h>
 #include <mm/page.h>
 #include <mm/km.h>
Index: kernel/genarch/src/acpi/madt.c
===================================================================
--- kernel/genarch/src/acpi/madt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/acpi/madt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <assert.h>
 #include <typedefs.h>
 #include <genarch/acpi/acpi.h>
@@ -41,10 +42,8 @@
 #include <arch/smp/smp.h>
 #include <panic.h>
-#include <debug.h>
 #include <config.h>
 #include <log.h>
 #include <mm/slab.h>
-#include <memstr.h>
-#include <sort.h>
+#include <gsort.h>
 
 struct acpi_madt *acpi_madt = NULL;
@@ -83,5 +82,5 @@
 static uint8_t madt_cpu_apic_id(size_t i)
 {
-	ASSERT(i < madt_l_apic_entry_cnt);
+	assert(i < madt_l_apic_entry_cnt);
 	
 	return ((struct madt_l_apic *)
@@ -91,5 +90,5 @@
 static bool madt_cpu_enabled(size_t i)
 {
-	ASSERT(i < madt_l_apic_entry_cnt);
+	assert(i < madt_l_apic_entry_cnt);
 	
 	/*
@@ -107,5 +106,5 @@
 static bool madt_cpu_bootstrap(size_t i)
 {
-	ASSERT(i < madt_l_apic_entry_cnt);
+	assert(i < madt_l_apic_entry_cnt);
 	
 	return ((struct madt_l_apic *)
@@ -177,5 +176,5 @@
     size_t i)
 {
-	ASSERT(override->source < sizeof(isa_irq_map) / sizeof(int));
+	assert(override->source < sizeof(isa_irq_map) / sizeof(int));
 	
 	isa_irq_map[override->source] = override->global_int;
Index: kernel/genarch/src/drivers/am335x/timer.c
===================================================================
--- kernel/genarch/src/drivers/am335x/timer.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/am335x/timer.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/am335x/timer.h>
 #include <mm/km.h>
@@ -90,6 +91,6 @@
 	size_t size;
 
-	ASSERT(id < TIMERS_MAX);
-	ASSERT(timer != NULL);
+	assert(id < TIMERS_MAX);
+	assert(timer != NULL);
 
 	if (id == DMTIMER1_1MS)
@@ -100,5 +101,5 @@
 
 	timer->regs = (void *) km_map(base_addr, size, PAGE_NOT_CACHEABLE);
-	ASSERT(timer->regs != NULL);
+	assert(timer->regs != NULL);
 
 	timer->id = id;
Index: kernel/genarch/src/drivers/dsrln/dsrlnin.c
===================================================================
--- kernel/genarch/src/drivers/dsrln/dsrlnin.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/dsrln/dsrlnin.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,9 +35,9 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/dsrln/dsrlnin.h>
 #include <console/chardev.h>
 #include <mm/slab.h>
 #include <arch/asm.h>
-#include <ddi/device.h>
 
 static irq_ownership_t dsrlnin_claim(irq_t *irq)
@@ -63,5 +63,4 @@
 		
 		irq_initialize(&instance->irq);
-		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = dsrlnin_claim;
@@ -75,6 +74,6 @@
 void dsrlnin_wire(dsrlnin_instance_t *instance, indev_t *srlnin)
 {
-	ASSERT(instance);
-	ASSERT(srlnin);
+	assert(instance);
+	assert(srlnin);
 	
 	instance->srlnin = srlnin;
Index: kernel/genarch/src/drivers/ega/ega.c
===================================================================
--- kernel/genarch/src/drivers/ega/ega.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/ega/ega.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <debug.h>
 #include <genarch/drivers/ega/ega.h>
 #include <putchar.h>
@@ -42,5 +43,5 @@
 #include <typedefs.h>
 #include <arch/asm.h>
-#include <memstr.h>
+#include <mem.h>
 #include <str.h>
 #include <console/chardev.h>
Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/i8042/i8042.h>
 #include <genarch/drivers/legacy/ia32/io.h>
@@ -43,5 +44,4 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
-#include <ddi/device.h>
 #include <time/delay.h>
 
@@ -112,5 +112,4 @@
 		
 		irq_initialize(&instance->irq);
-		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = i8042_claim;
@@ -124,6 +123,6 @@
 void i8042_wire(i8042_instance_t *instance, indev_t *kbrdin)
 {
-	ASSERT(instance);
-	ASSERT(kbrdin);
+	assert(instance);
+	assert(kbrdin);
 	
 	i8042_clear_buffer(instance->i8042);
Index: kernel/genarch/src/drivers/ns16550/ns16550.c
===================================================================
--- kernel/genarch/src/drivers/ns16550/ns16550.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/ns16550/ns16550.h>
 #include <ddi/irq.h>
@@ -40,5 +41,4 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
-#include <ddi/device.h>
 #include <str.h>
 
@@ -137,5 +137,4 @@
 		
 		irq_initialize(&instance->irq);
-		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = ns16550_claim;
@@ -157,6 +156,6 @@
 void ns16550_wire(ns16550_instance_t *instance, indev_t *input)
 {
-	ASSERT(instance);
-	ASSERT(input);
+	assert(instance);
+	assert(input);
 	
 	instance->input = input;
Index: kernel/genarch/src/drivers/omap/uart.c
===================================================================
--- kernel/genarch/src/drivers/omap/uart.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/omap/uart.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,6 +35,6 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/omap/uart.h>
-#include <ddi/device.h>
 #include <str.h>
 #include <mm/km.h>
@@ -86,8 +86,8 @@
     omap_uart_t *uart, inr_t interrupt, uintptr_t addr, size_t size)
 {
-	ASSERT(uart);
+	assert(uart);
 	uart->regs = (void *)km_map(addr, size, PAGE_NOT_CACHEABLE);
 
-	ASSERT(uart->regs);
+	assert(uart->regs);
 
 	/* Soft reset the port */
@@ -160,5 +160,4 @@
 	/* Initialize IRQ */
 	irq_initialize(&uart->irq);
-	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = interrupt;
 	uart->irq.claim = omap_uart_claim;
@@ -171,5 +170,5 @@
 void omap_uart_input_wire(omap_uart_t *uart, indev_t *indev)
 {
-	ASSERT(uart);
+	assert(uart);
 	/* Set indev */
 	uart->indev = indev;
Index: kernel/genarch/src/drivers/pl011/pl011.c
===================================================================
--- kernel/genarch/src/drivers/pl011/pl011.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/pl011/pl011.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,8 +35,8 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/pl011/pl011.h>
 #include <console/chardev.h>
 #include <console/console.h>
-#include <ddi/device.h>
 #include <arch/asm.h>
 #include <mm/slab.h>
@@ -98,8 +98,8 @@
 bool pl011_uart_init(pl011_uart_t *uart, inr_t interrupt, uintptr_t addr)
 {
-	ASSERT(uart);
+	assert(uart);
 	uart->regs = (void*)km_map(addr, sizeof(pl011_uart_regs_t),
 				   PAGE_NOT_CACHEABLE);
-	ASSERT(uart->regs);
+	assert(uart->regs);
 
 	/* Disable UART */
@@ -126,5 +126,4 @@
 	/* Initialize IRQ */
 	irq_initialize(&uart->irq);
-	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = interrupt;
 	uart->irq.claim = pl011_uart_claim;
@@ -137,6 +136,6 @@
 void pl011_uart_input_wire(pl011_uart_t *uart, indev_t *indev)
 {
-	ASSERT(uart);
-	ASSERT(indev);
+	assert(uart);
+	assert(indev);
 
 	uart->indev = indev;
Index: kernel/genarch/src/drivers/pl050/pl050.c
===================================================================
--- kernel/genarch/src/drivers/pl050/pl050.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/pl050/pl050.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,4 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
-#include <ddi/device.h>
 
 #define PL050_KEY_RELEASE 0xF0
@@ -87,5 +86,4 @@
 
 		irq_initialize(&instance->irq);
-		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = pl050_claim;
Index: kernel/genarch/src/drivers/s3c24xx/uart.c
===================================================================
--- kernel/genarch/src/drivers/s3c24xx/uart.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/s3c24xx/uart.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,8 +38,8 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/s3c24xx/uart.h>
 #include <console/chardev.h>
 #include <console/console.h>
-#include <ddi/device.h>
 #include <arch/asm.h>
 #include <mm/slab.h>
@@ -122,5 +122,4 @@
 	/* Initialize IRQ structure. */
 	irq_initialize(&uart->irq);
-	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = inr;
 	uart->irq.claim = s3c24xx_uart_claim;
@@ -161,6 +160,6 @@
 void s3c24xx_uart_input_wire(s3c24xx_uart_t *uart, indev_t *indev)
 {
-	ASSERT(uart);
-	ASSERT(indev);
+	assert(uart);
+	assert(indev);
 
 	uart->indev = indev;
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
  */
 
+#include <assert.h>
 #include <genarch/drivers/via-cuda/cuda.h>
 #include <console/chardev.h>
@@ -39,7 +40,6 @@
 #include <arch/asm.h>
 #include <mm/slab.h>
-#include <ddi/device.h>
 #include <synch/spinlock.h>
-#include <memstr.h>
+#include <mem.h>
 
 static irq_ownership_t cuda_claim(irq_t *irq);
@@ -105,5 +105,4 @@
 
 		irq_initialize(&instance->irq);
-		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = cuda_claim;
@@ -123,6 +122,6 @@
 	cuda_t *dev = instance->cuda;
 
-	ASSERT(instance);
-	ASSERT(kbrdin);
+	assert(instance);
+	assert(kbrdin);
 
 	instance->kbrdin = kbrdin;
@@ -341,5 +340,5 @@
 	cuda_t *dev = instance->cuda;
 
-	ASSERT(instance->xstate == cx_listen);
+	assert(instance->xstate == cx_listen);
 
 	if (instance->snd_bytes == 0)
Index: kernel/genarch/src/fb/bfb.c
===================================================================
--- kernel/genarch/src/fb/bfb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/fb/bfb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <debug.h>
 #include <typedefs.h>
 #include <genarch/fb/fb.h>
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/fb/fb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,6 @@
  */
 
+#include <assert.h>
+#include <debug.h>
 #include <genarch/fb/font-8x16.h>
 #include <genarch/fb/fb.h>
@@ -43,5 +45,5 @@
 #include <align.h>
 #include <panic.h>
-#include <memstr.h>
+#include <mem.h>
 #include <config.h>
 #include <bitops.h>
@@ -511,8 +513,8 @@
 outdev_t *fb_init(fb_properties_t *props)
 {
-	ASSERT(props);
-	ASSERT(props->x > 0);
-	ASSERT(props->y > 0);
-	ASSERT(props->scan > 0);
+	assert(props);
+	assert(props->x > 0);
+	assert(props->y > 0);
+	assert(props->scan > 0);
 	
 	rgb_conv_t rgb_conv;
Index: kernel/genarch/src/kbrd/kbrd.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/kbrd/kbrd.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <assert.h>
 #include <genarch/kbrd/kbrd.h>
 #include <genarch/kbrd/scanc.h>
@@ -194,6 +195,6 @@
 indev_t *kbrd_wire(kbrd_instance_t *instance, indev_t *sink)
 {
-	ASSERT(instance);
-	ASSERT(sink);
+	assert(instance);
+	assert(sink);
 	
 	instance->sink = sink;
Index: kernel/genarch/src/kbrd/kbrd_at.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd_at.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/kbrd/kbrd_at.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <assert.h>
 #include <genarch/kbrd/kbrd.h>
 #include <genarch/kbrd/scanc.h>
@@ -192,6 +193,6 @@
 indev_t *kbrd_wire(kbrd_instance_t *instance, indev_t *sink)
 {
-	ASSERT(instance);
-	ASSERT(sink);
+	assert(instance);
+	assert(sink);
 	
 	instance->sink = sink;
Index: kernel/genarch/src/mm/as_ht.c
===================================================================
--- kernel/genarch/src/mm/as_ht.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/mm/as_ht.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,5 +43,4 @@
 #include <mm/slab.h>
 #include <typedefs.h>
-#include <memstr.h>
 #include <adt/hash_table.h>
 #include <synch/mutex.h>
@@ -76,5 +75,5 @@
 {
 	if (flags & FLAG_AS_KERNEL) {
-		hash_table_create(&page_ht, PAGE_HT_ENTRIES, 2, &ht_operations);
+		hash_table_create(&page_ht, 0, 0, &ht_ops);
 		pte_cache = slab_cache_create("pte_t", sizeof(pte_t), 0,
 		    NULL, NULL, SLAB_CACHE_MAGDEFERRED);
Index: kernel/genarch/src/mm/as_pt.c
===================================================================
--- kernel/genarch/src/mm/as_pt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/mm/as_pt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,5 @@
 #include <arch/mm/as.h>
 #include <typedefs.h>
-#include <memstr.h>
+#include <mem.h>
 #include <arch.h>
 
Index: kernel/genarch/src/mm/asid.c
===================================================================
--- kernel/genarch/src/mm/asid.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/mm/asid.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -57,4 +57,5 @@
  */
 
+#include <assert.h>
 #include <mm/asid.h>
 #include <mm/as.h>
@@ -64,5 +65,4 @@
 #include <synch/mutex.h>
 #include <adt/list.h>
-#include <debug.h>
 
 static size_t asids_allocated = 0;
@@ -78,6 +78,6 @@
 	as_t *as;
 
-	ASSERT(interrupts_disabled());
-	ASSERT(spinlock_locked(&asidlock));
+	assert(interrupts_disabled());
+	assert(spinlock_locked(&asidlock));
 
 	/*
@@ -98,5 +98,5 @@
 		 */
 		tmp = list_first(&inactive_as_with_asid_list);
-		ASSERT(tmp != NULL);
+		assert(tmp != NULL);
 		list_remove(tmp);
 		
@@ -108,5 +108,5 @@
 		 */
 		asid = as->asid;
-		ASSERT(asid != ASID_INVALID);
+		assert(asid != ASID_INVALID);
 
 		/*
